/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_users
#define headerfile_winix_core_users

#include <map>
#include "user.h"
#include "ugcontainer.h"
#include "lastcontainer.h"
#include "cur.h"
#include "db/db.h"


class Users
{
typedef UGContainer<User> Table;
Table table;

	Cur * cur;
	long how_many_logged;

public:

	typedef Table::Iterator Iterator;
	typedef Table::SizeType SizeType;

	LastContainer last;

	Users();

	void SetCur(Cur * pcur);

	void Clear();
	void ReadUsers(Db * db);
	void SetTimeZoneOffset(int offset); // !! temporarily one time_zone for all users
	bool AddUser(const User & user);
	bool IsUser(const std::wstring & name);
	User * GetUser(long user_id);
	User * GetUser(const std::wstring & name);
	long GetUserId(const std::wstring & name);
	Iterator Begin();
	Iterator End();
	SizeType Size();
	User & operator[](SizeType pos);

	bool LoginUser(long user_id, bool remember_me, bool use_ses_log = false);
	void LogoutCurrentUser();

	void IncrementLoggedUsers();
	long HowManyLogged();
};








#endif
