/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "logout.h"
#include "core/plugin.h"



namespace Fun
{


Logout::Logout()
{
	fun.url = L"logout";
}


void Logout::LogoutCurrentUser()
{
	if( cur->session && cur->session->puser )
	{
		long user_id = cur->session->puser->id;
		plugin.Call(WINIX_PREPARE_USER_LOGGED_OUT);

		system->users.LogoutCurrentUser();
		plugin.Call(WINIX_USER_LOGGED_OUT, user_id);
	}
}


void Logout::MakeGet()
{
	if( cur->session->puser )
	{
		LogoutCurrentUser();
		system->RedirectToLastItem();
	}
}


} // namespace
